# $Id: kktn.pl,v 1.17 2001/08/07 23:22:21 billl Exp $
# kleinigkeiten

package kktn;

# Usage: &lv(TIME,MESSAGE)
# uses at command to send mail at a particular time

# need all of the flags for mail so doesn't start looking around for files
# puts lines above and below the message

sub lv {
    if ($#_<0) {print "USAGE: lv time message; time=eg 0815jan24 or name:0815jan24\n";exit;}
    $who = `whoami`;
    chop $who;
    $time=shift;
    if ($time=~/:/) {($who,$time) = split(/:/,$time);}
    $prog=qq*open(M,"| mail $who\\\@localhost");print M ("_"x60),qq+\\n@_\\n+,("_"x60);close M;*;
    open(O,"|at $time");
    print O qq*perl -e '$prog'\n*;
}

# N MINUTE WARNING
sub lv2 {
    $who = `whoami`;
    $warn = 5;
    chop $who;
    $time=shift;
    $time2 = $time-$warn;
    if ($time2%100>60) { $time2=int($time2/100)*100+$time2%100-40; }
    # N MINUTE WARNING
    $prog=qq*open(M,"| mail -i -n -N $who\\\@localhost");
    print M qq|$warn MIN WARNING: \\n|,("_"x60),qq+\\n@_\\n+,("_"x60);close M;*;
    open(O,qq*|at now + $time2 minutes*);
    print O qq*perl -e '$prog'\n*;
    close O;
    # NOW GO
    $prog=qq*open(M,"| mail -i -n -N $who\\\@localhost");
    print M qq|NOW GO: \\n|,("_"x60),qq+\\n@_\\n+,("_"x60);close M;*;
    open(O,qq*|at now + $time minutes*);
    print O qq*perl -e '$prog'\n*;
    close O;
}

# does same thing as unix cut routine but less intimidating
sub cut {
    while ($_ = $_[0],/^[a-z]/) {
	$flag = shift @_;
	if (substr($flag,0,1) eq "s") {
	    $skip = substr($flag,1); 
	} else { die "Unknown flag: $flag\n"; }		
    }
    @y=eval($_[0]);
    open(IN,"< $_[1]") || die "Can't open $_[1]\n";
    while (<IN>){
	if ($. <= $skip) {print; next;}
	split;
	for $y(@y) {
	    print "$_[$y] ";
	}
	print "\n";
    }
}

# cut out the section of FILE between MIN and MAX
sub vcut {
    ($file,$min,$max) = @_;
    open(IN,"< $file");
    while (<IN>) {
	split;
	$_[0] >= $min && print;
	$_[0] >= $max && exit;
    }
}

# run ls command but only list files with certain flags set
sub lx {
    $arg = shift;
    opendir(DOT,".");    
    @files = grep(!/^\.\.?$/,readdir(DOT)); # all the files except . and ..
    grep(($_=qq|-$arg "|.$_.q|"|),@files);  # put a -arg operator in front of each file
    @out=grep(eval($_),@files);             # eval each string
    grep((s/[^"]+"([^"]+)"/$1/),@out);      # string off the operator and "
    @out = sort {(-M $a) <=> (-M $b)} @out; # sort by age
    print "@out\n";
}

# get rid of the links and replace them with the thing itself
sub replinks {
    $arg = "-$_[0]"; # can't figure out how to get this to eval
    opendir(DOT,".");    
    @files = grep(!/^\.\.?$/,readdir(DOT));
    for $f (@files) {
	if (-l $f) {
	    $l = readlink($f);
	    if (-f $l) {
		unlink($f);
		print "Copying $l to $f\n";
		`cp $l $f;`
		}
	    }
    }
}

# replace str1 with str2 in files
sub repl {
    ($ARGV[0] eq "help") and die "repl str1 str2 [file1 file2 ...]
  replaces str1 with str2 in multiple files.\n";
    $| = 1;
    $str1 = shift; $str2 = shift; 
    local($flag=1,$change_made=0,$count=0,$nn=0);
    if ($#_<0) { # with no file args get everything under RCS
	opendir(RCS,"RCS");
	@files = grep(/,v$/,readdir(RCS)); # just read ,v files (not . ..)
	foreach (@files) { $_ =~ s/,v//; } # get rid of the ,v part
    } else { @files = @_; }

    foreach $bb (@files) {
	if (!-f $bb) { print "$bb not present.\n"; next; }
	$count = `/bin/grep -c $str1 $bb` + 0;
	@stat = stat(_);
	if ($count>0) {
	    $nn=0;
	    `mv -f $bb $bb.SAV`; print "* [$count] $bb => $bb.SAV\n";
	    open(IN,"<$bb.SAV");
	    open(OUT,">$bb");
	    while (<IN>) { 
		if (/$str1/) {s/$str1/$str2/g;print "  ==> $_"; $nn++;}
		print OUT;}
	    chmod $stat[2],$bb;
	    if ($nn!=$count) { print "Count discrepency: $nn, $count\n"; }
	}
    }
}

1;
